## picolibc 1.8

=== CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

cmake_minimum_required(VERSION 3.20.0)

project(Picolibc VERSION 1.8 LANGUAGES C ASM)

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "arm64")
  set(CMAKE_SYSTEM_PROCESSOR "aarch64")
endif()

set(CMAKE_SYSTEM_SUB_PROCESSOR ${CMAKE_SYSTEM_PROCESSOR})

if(${CMAKE_SYSTEM_PROCESSOR} STREQUAL "i686" OR
    ${CMAKE_SYSTEM_PROCESSOR} STREQUAL "x86_64") 
  set(CMAKE_SYSTEM_PROCESSOR "x86")
endif()

if(ZEPHYR_BASE)
  if(NOT CONFIG_PICOLIBC_USE_MODULE)
    return()
  endif()
  include(zephyr/zephyr.cmake)
endif()

include(cmake/picolibc.cmake)

enable_testing()

set(CMAKE_TRY_COMPILE_TARGET_TYPE STATIC_LIBRARY)

# Set all configure values to defaults for now

# Use atomics for fgetc/ungetc for re-entrancy
set(ATOMIC_UNGETC 1)

# Always optimize strcmp for performance
if(NOT DEFINED FAST_STRCMP)
  option(FAST_STRCMP "Always optimize strcmp for performance" ON)
endif()

# Obsoleted. Use regular syscalls
set(MISSING_SYSCALL_NAMES 0)

# use global errno variable
if(NOT DEFINED NEWLIB_GLOBAL_ERRNO)
  option(NEWLIB_GLOBAL_ERRNO "use global errno variable" OFF)
endif()

# use thread local storage
if(NOT DEFINED PICOLIBC_TLS)
  option(PICOLIBC_TLS "use thread local storage for static data" ON)
endif()

# use thread local storage
set(NEWLIB_TLS ${PICOLIBC_TLS})

# Use open/close/read/write in tinystdio
option(POSIX_IO "Provide fopen/fdopen using POSIX I/O (open, close, read, write, lseek)" ON)

option(POSIX_CONSOLE "Use POSIX I/O for stdin/stdout/stderr" OFF)

# Optimize for space over speed

if(NOT DEFINED PREFER_SIZE_OVER_SPEED)
  if(CMAKE_BUILD_TYPE STREQUAL "MinSizeRel")
    set(default_prefer_size 1)
  else()
    set(default_prefer_size 0)
  endif()
  option(PREFER_SIZE_OVER_SPEED ${default_prefer_size})
endif()

# Obsoleted. Reentrant syscalls provided for us
set(REENTRANT_SYSCALLS_PROVIDED 0)

# Use tiny stdio from gcc avr
option(TINY_STDIO "Use tiny stdio from avr libc" ON)

if(NOT TLS_MODEL)
  set(TLS_MODEL "local-exec")
endif()

set(_ATEXIT_DYNAMIC_ALLOC 0)

set(_FSEEK_OPTIMIZATION 0)

set(_FVWRITE_IN_STREAMIO 0)

try_compile(_HAVE_ALIAS_ATTRIBUTE ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-alias-attribute.c)

# The compiler REALLY has the attribute __alloc_size__
try_compile(_HAVE_ALLOC_SIZE ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-alloc-size.c)

# The compiler supports the always_inline function attribute
try_compile(_HAVE_ATTRIBUTE_ALWAYS_INLINE ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-attribute-always-inline.c)

# The compiler supports the gnu_inline function attribute
try_compile(_HAVE_ATTRIBUTE_GNU_INLINE  ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-attribute-gnu-inline.c)

# Use bitfields in packed structs
set(_HAVE_BITFIELDS_IN_PACKED_STRUCTS 1)

# The compiler supports __builtin_alloca
set(_HAVE_BUILTIN_ALLOCA 1)

# The compiler supports __builtin_copysign
set(_HAVE_BUILTIN_COPYSIGN 1)

# The compiler supports __builtin_copysignl
set(_HAVE_BUILTIN_COPYSIGNL 1)

# The compiler supports __builtin_ctz
set(_HAVE_BUILTIN_CTZ 1)

# The compiler supports __builtin_ctzl
set(_HAVE_BUILTIN_CTZL 1)

# The compiler supports __builtin_ctzll
set(_HAVE_BUILTIN_CTZLL 1)

# Compiler has __builtin_expect
set(_HAVE_BUILTIN_EXPECT 1)

# The compiler supports __builtin_ffs
set(_HAVE_BUILTIN_FFS 1)

# The compiler supports __builtin_ffsl
set(_HAVE_BUILTIN_FFSL 1)

# The compiler supports __builtin_ffsll
set(_HAVE_BUILTIN_FFSLL 1)

# The compiler supports __builtin_finitel
set(_HAVE_BUILTIN_FINITEL 1)

# The compiler supports __builtin_isfinite
set(_HAVE_BUILTIN_ISFINITE 1)

# The compiler supports __builtin_isinf
set(_HAVE_BUILTIN_ISINF 1)

# The compiler supports __builtin_isinfl
set(_HAVE_BUILTIN_ISINFL 1)

# The compiler supports __builtin_isnan
set(_HAVE_BUILTIN_ISNAN 1)

# The compiler supports __builtin_isnanl
set(_HAVE_BUILTIN_ISNANL 1)

# Compiler has __builtin_mul_overflow
set(_HAVE_BUILTIN_MUL_OVERFLOW 1)

# Compiler has __builtin_add_overflow
set(_HAVE_BUILTIN_ADD_OVERFLOW 1)

# Compiler flag to prevent detecting memcpy/memset patterns
set(_HAVE_CC_INHIBIT_LOOP_TO_LIBCALL 1)

# Compiler supports _Complex
try_compile(_HAVE_COMPLEX ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-complex.c)

set(_HAVE_FCNTL 0)

set(_HAVE_FORMAT_ATTRIBUTE 1)

# IEEE fp funcs available
set(_HAVE_IEEEFP_FUNCS 0)

# compiler supports INIT_ARRAY sections
set(_HAVE_INITFINI_ARRAY 1)

# Support _init() and _fini() functions
set(_HAVE_INIT_FINI 1)

# Compiler has long double type
try_compile(_HAVE_LONG_DOUBLE ${PROJECT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/cmake/have-long-double.c)

# Compiler attribute to prevent the optimizer from adding new builtin calls
set(_HAVE_NO_BUILTIN_ATTRIBUTE 0)

# _set_tls and _init_tls functions available
if(NOT DEFINED _HAVE_PICOLIBC_TLS_API)
  set(_HAVE_PICOLIBC_TLS_API 0)
endif()

set(_HAVE_SEMIHOST 1)
set(_HAVE_WEAK_ATTRIBUTE 1)
set(_ICONV_ENABLE_EXTERNAL_CCS 0)
set(_ICONV_FROM_ENCODING_ 1)
set(_ICONV_FROM_ENCODING_BIG5 1)
set(_ICONV_FROM_ENCODING_CP775 1)
set(_ICONV_FROM_ENCODING_CP850 1)
set(_ICONV_FROM_ENCODING_CP852 1)
set(_ICONV_FROM_ENCODING_CP855 1)
set(_ICONV_FROM_ENCODING_CP866 1)
set(_ICONV_FROM_ENCODING_EUC_JP 1)
set(_ICONV_FROM_ENCODING_EUC_KR 1)
set(_ICONV_FROM_ENCODING_EUC_TW 1)
set(_ICONV_FROM_ENCODING_ISO_8859_1 1)
set(_ICONV_FROM_ENCODING_ISO_8859_10 1)
set(_ICONV_FROM_ENCODING_ISO_8859_11 1)
set(_ICONV_FROM_ENCODING_ISO_8859_13 1)
set(_ICONV_FROM_ENCODING_ISO_8859_14 1)
set(_ICONV_FROM_ENCODING_ISO_8859_15 1)
set(_ICONV_FROM_ENCODING_ISO_8859_2 1)
set(_ICONV_FROM_ENCODING_ISO_8859_3 1)
set(_ICONV_FROM_ENCODING_ISO_8859_4 1)
set(_ICONV_FROM_ENCODING_ISO_8859_5 1)
set(_ICONV_FROM_ENCODING_ISO_8859_6 1)
set(_ICONV_FROM_ENCODING_ISO_8859_7 1)
set(_ICONV_FROM_ENCODING_ISO_8859_8 1)
set(_ICONV_FROM_ENCODING_ISO_8859_9 1)
set(_ICONV_FROM_ENCODING_ISO_IR_111 1)
set(_ICONV_FROM_ENCODING_KOI8_R 1)
set(_ICONV_FROM_ENCODING_KOI8_RU 1)
set(_ICONV_FROM_ENCODING_KOI8_U 1)
set(_ICONV_FROM_ENCODING_KOI8_UNI 1)
set(_ICONV_FROM_ENCODING_UCS_2 1)
set(_ICONV_FROM_ENCODING_UCS_2BE 1)
set(_ICONV_FROM_ENCODING_UCS_2LE 1)
set(_ICONV_FROM_ENCODING_UCS_2_INTERNAL 1)
set(_ICONV_FROM_ENCODING_UCS_4 1)
set(_ICONV_FROM_ENCODING_UCS_4BE 1)
set(_ICONV_FROM_ENCODING_UCS_4LE 1)
set(_ICONV_FROM_ENCODING_UCS_4_INTERNAL 1)
set(_ICONV_FROM_ENCODING_US_ASCII 1)
set(_ICONV_FROM_ENCODING_UTF_16 1)
set(_ICONV_FROM_ENCODING_UTF_16BE 1)
set(_ICONV_FROM_ENCODING_UTF_16LE 1)
set(_ICONV_FROM_ENCODING_UTF_8 1)
set(_ICONV_FROM_ENCODING_WIN_1250 1)
set(_ICONV_FROM_ENCODING_WIN_1251 1)
set(_ICONV_FROM_ENCODING_WIN_1252 1)
set(_ICONV_FROM_ENCODING_WIN_1253 1)
set(_ICONV_FROM_ENCODING_WIN_1254 1)
set(_ICONV_FROM_ENCODING_WIN_1255 1)
set(_ICONV_FROM_ENCODING_WIN_1256 1)
set(_ICONV_FROM_ENCODING_WIN_1257 1)
set(_ICONV_FROM_ENCODING_WIN_1258 1)
set(_ICONV_TO_ENCODING_ 1)
set(_ICONV_TO_ENCODING_BIG5 1)
set(_ICONV_TO_ENCODING_CP775 1)
set(_ICONV_TO_ENCODING_CP850 1)
set(_ICONV_TO_ENCODING_CP852 1)
set(_ICONV_TO_ENCODING_CP855 1)
set(_ICONV_TO_ENCODING_CP866 1)
set(_ICONV_TO_ENCODING_EUC_JP 1)
set(_ICONV_TO_ENCODING_EUC_KR 1)
set(_ICONV_TO_ENCODING_EUC_TW 1)
set(_ICONV_TO_ENCODING_ISO_8859_1 1)
set(_ICONV_TO_ENCODING_ISO_8859_10 1)
set(_ICONV_TO_ENCODING_ISO_8859_11 1)
set(_ICONV_TO_ENCODING_ISO_8859_13 1)
set(_ICONV_TO_ENCODING_ISO_8859_14 1)
set(_ICONV_TO_ENCODING_ISO_8859_15 1)
set(_ICONV_TO_ENCODING_ISO_8859_2 1)
set(_ICONV_TO_ENCODING_ISO_8859_3 1)
set(_ICONV_TO_ENCODING_ISO_8859_4 1)
set(_ICONV_TO_ENCODING_ISO_8859_5 1)
set(_ICONV_TO_ENCODING_ISO_8859_6 1)
set(_ICONV_TO_ENCODING_ISO_8859_7 1)
set(_ICONV_TO_ENCODING_ISO_8859_8 1)
set(_ICONV_TO_ENCODING_ISO_8859_9 1)
set(_ICONV_TO_ENCODING_ISO_IR_111 1)
set(_ICONV_TO_ENCODING_KOI8_R 1)
set(_ICONV_TO_ENCODING_KOI8_RU 1)
set(_ICONV_TO_ENCODING_KOI8_U 1)
set(_ICONV_TO_ENCODING_KOI8_UNI 1)
set(_ICONV_TO_ENCODING_UCS_2 1)
set(_ICONV_TO_ENCODING_UCS_2BE 1)
set(_ICONV_TO_ENCODING_UCS_2LE 1)
set(_ICONV_TO_ENCODING_UCS_2_INTERNAL 1)
set(_ICONV_TO_ENCODING_UCS_4 1)
set(_ICONV_TO_ENCODING_UCS_4BE 1)
set(_ICONV_TO_ENCODING_UCS_4LE 1)
set(_ICONV_TO_ENCODING_UCS_4_INTERNAL 1)
set(_ICONV_TO_ENCODING_US_ASCII 1)
set(_ICONV_TO_ENCODING_UTF_16 1)
set(_ICONV_TO_ENCODING_UTF_16BE 1)
set(_ICONV_TO_ENCODING_UTF_16LE 1)
set(_ICONV_TO_ENCODING_UTF_8 1)
set(_ICONV_TO_ENCODING_WIN_1250 1)
set(_ICONV_TO_ENCODING_WIN_1251 1)
set(_ICONV_TO_ENCODING_WIN_1252 1)
set(_ICONV_TO_ENCODING_WIN_1253 1)
set(_ICONV_TO_ENCODING_WIN_1254 1)
set(_ICONV_TO_ENCODING_WIN_1255 1)
set(_ICONV_TO_ENCODING_WIN_1256 1)
set(_ICONV_TO_ENCODING_WIN_1257 1)
set(_ICONV_TO_ENCODING_WIN_1258 1)

# math library does not set errno (offering only ieee semantics)
set(_IEEE_LIBM 1)

if(NOT DEFINED _IO_FLOAT_EXACT)
  option(_IO_FLOAT_EXACT "Provide exact binary/decimal conversion for printf/scanf" 1)
endif()

set(_LITE_EXIT 1)

set(_PICO_EXIT 1)

if(NOT DEFINED _MB_CAPABLE)
  option(_MB_CAPABLE "Enable multi-byte support" 0)
endif()

set(_MB_LEN_MAX 1 1)

set(_NANO_FORMATTED_IO 0)

option(_NANO_MALLOC "Use smaller malloc implementation" 1)

set(_REENT_GLOBAL_ATEXIT 0)

set(_UNBUF_STREAM_OPT 0)

if(NOT DEFINED _WANT_IO_C99_FORMATS)
  option(_WANT_IO_C99_FORMATS "Support C99 formats in printf/scanf" ON)
endif()

if(NOT DEFINED _WANT_IO_LONG_LONG)
  option(_WANT_IO_LONG_LONG "Support long long in integer printf/scanf" OFF)
endif()

if(NOT DEFINED _WANT_IO_POS_ARGS)
  option(_WANT_IO_POS_ARGS "Support positional args in integer printf/scanf" OFF)
endif()

option(__IO_FLOAT "Support floating point in printf/scanf by default" OFF)

if(NOT DEFINED _WANT_IO_PERCENT_B)
  option(_WANT_IO_PERCENT_B "Support %b/%B formats in printf/scanf" OFF)
endif()

if(NOT DEFINED FORMAT_DEFAULT_DOUBLE)
  set(FORMAT_DEFAULT_DOUBLE ${__IO_FLOAT})
endif()

if(NOT DEFINED FORMAT_DEFAULT_FLOAT)
  set(FORMAT_DEFAULT_FLOAT 0)
endif()

if(NOT DEFINED FORMAT_DEFAULT_INTEGER)
  set(FORMAT_DEFAULT_INTEGER NOT ${__IO_FLOAT})
endif()

# math library sets errno
set(_WANT_MATH_ERRNO 0)

set(_WANT_REENT_SMALL 0)

set(_WANT_REGISTER_FINI 0)

# Obsoleted. Define time_t to long instead of using a 64-bit type
set(_WANT_USE_LONG_TIME_T 0)

set(_WIDE_ORIENT 0)

# locale support
if(NOT DEFINED __HAVE_LOCALE_INFO__)
  option(__HAVE_LOCALE_INFO__ "Provide locale support" 0)
endif()

# extended locale support
if(NOT DEFINED __HAVE_LOCALE_INFO_EXTENDED__)
  option(__HAVE_LOCALE_INFO_EXTENDED__ "Provide even more locale support" 0)
endif()

=== meson_options.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2019 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
option('fast-strcmp', type: 'boolean', value: true,
       description: 'Always optimize strcmp for performance')

option('have-alias-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Compiler supports __alias__ attribute')

option('have-format-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Compiler supports __format__ attribute')

option('have-weak-attribute', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'Compiler supports __weak__ attribute')

option('multilib', type: 'boolean', value: true,
       description: 'Enable multilib compile')

option('multilib-list', type: 'array', value: [],
       description: 'List of multilib configurations to build for')

option('build-type-subdir', type: 'string',
       description: 'Build-type subdir. Also skips installing .specs file')

option('picolib', type: 'boolean', value: true,
       description: 'Include pico lib bits')

option('picocrt', type: 'boolean', value: true,
       description: 'Include pico crt bits')

option('semihost', type: 'boolean', value: true,
       description: 'Include semihost bits')

option('specsdir', type: 'string',
       description: 'Installation directory for .specs file')

option('sysroot-install', type: 'boolean', value: false,
       description: 'Install in gcc sysroot')

option('sysroot-install-skip-checks', type: 'boolean', value: false,
       description: 'Skip sysroot path checks during config')

option('system-libc', type: 'boolean', value: false,
       description: 'Install as system C library')
					      
option('picoexit', type: 'boolean', value: true,
       description: 'Smaller exit/atexit/onexit code')

option('fortify-source', type: 'combo', choices: ['none', '1', '2'], value: 'none',
       description: 'Set _FORTIFY_SOURCE=<value>')

option('use-stdlib', type: 'boolean', value: false,
       description: 'Do not bypass the standard system library with -nostdlib (useful for native testing)')

option('profile', type: 'boolean', value: false,
       description: 'Enable profiling by adding -pg -no-pie to compile flags')

#
# Testing options
#
option('native-tests', type: 'boolean', value: false,
       description: 'Run math tests against native libc too')
option('tests', type: 'boolean', value: false,
       description: 'Enable tests')
option('tests-enable-stack-protector', type: 'boolean', value: true,
       description: 'tests enable stack protector')
option('tests-enable-full-malloc-stress', type: 'boolean', value: false,
       description: 'tests enable stress test for full malloc')
option('tests-enable-posix-io', type: 'boolean', value: true,
       description: 'tests enable posix-io when available')

option('tinystdio', type: 'boolean', value: true,
       description: 'Use tiny stdio from avr libc')

#
# Options applying to both legacy stdio and tinystdio
#
option('io-c99-formats', type: 'boolean', value: true,
       description: 'enable C99 support in IO functions like printf/scanf')
option('newlib-io-c99-formats', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable C99 support in IO functions like printf/scanf')
option('io-long-long', type: 'boolean', value: false,
       description: 'enable long long type support in IO functions like printf/scanf')
option('newlib-io-long-long', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable long long type support in IO functions like printf/scanf')
option('io-pos-args', type: 'boolean', value: false,
       description: 'enable printf-family positional arg support (always enabled for tinystdio float)')
option('newlib-io-pos-args', type: 'combo', choices: ['true', 'false', 'auto'], value: 'auto',
       description: 'enable printf-family positional arg support (always enabled for tinystdio float)')
option('io-percent-b', type: 'boolean', value: false,
       description: 'enable proposed %b/%B format in printf and scanf in tinystdio (default: false)')
option('io-long-double', type: 'boolean', value: false,
       description: 'enable long double type support in IO functions printf/scanf')
option('newlib-io-long-double', type: 'boolean', value: false,
       description: 'enable long double type support in IO functions printf/scanf')

#
# Options applying only to tinystdio
#
option('io-float-exact', type: 'boolean', value: true,
       description: 'use float/string code which supports round-tripping')
option('atomic-ungetc', type: 'boolean', value: true,
       description: 'use atomics in fgetc/ungetc to make them re-entrant')
option('posix-io', type: 'boolean', value: true,
       description: 'Provide fopen/fdopen using POSIX I/O (open, close, read, write, lseek)')
option('posix-console', type: 'boolean', value: false,
       description: 'Use POSIX I/O for stdin/stdout/stderr')
option('format-default', type: 'combo', choices: ['double', 'float', 'integer'], value: 'double',
       description: 'which printf/scanf versions should be the default')
option('printf-aliases', type: 'boolean', value: true,
       description: 'Allow link-time printf aliases')

#
# Options applying to only legacy stdio
#
option('newlib-elix-level', type: 'integer', value: 4,
       description: 'desired elix library level (0-4)')
option('newlib-fseek-optimization', type: 'boolean', value: false,
       description: 'enable fseek optimization')
option('newlib-fvwrite-in-streamio', type: 'boolean', value: false,
       description: 'disable iov in streamio')
option('newlib-global-stdio-streams', type: 'boolean', value: false,
       description: 'enable global stdio streams')
option('newlib-io-float', type: 'boolean', value: false,
       description: 'enable printf/scanf family float support')
option('newlib-nano-formatted-io', type: 'boolean', value: false,
       description: 'Use nano version formatted IO')
option('newlib-reent-small', type: 'boolean', value: false,
       description: 'enable small reentrant struct support')
option('newlib-stdio64', type: 'boolean', value: true,
       description: 'Include stdio64 with newlib stdio')
option('newlib-unbuf-stream-opt', type: 'boolean', value: false,
       description: 'enable unbuffered stream optimization in streamio')
option('newlib-wide-orient', type: 'boolean', value: false,
       description: 'Turn off wide orientation in streamio')
option('newlib-have-fcntl', type: 'boolean', value: false,
       description: 'System has fcntl function')

#
# Internationalization options
#

option('newlib-iconv-encodings', type: 'array',
       description: 'enable specific comma-separated list of bidirectional iconv encodings to be built-in')
option('newlib-iconv-from-encodings', type: 'array',
       description: 'enable specific comma-separated list of "from" iconv encodings to be built-in')
option('newlib-iconv-to-encodings', type: 'array',
       description: 'enable specific comma-separated list of "to" iconv encodings to be built-in')
option('newlib-iconv-external-ccs', type: 'boolean', value:false,
       description: 'Load iconv CCS tables from files rather than having them built-in')
option('newlib-iconv-dir', type: 'string',
       description: 'Installation directory for iconv CCS files')
option('newlib-iconv-runtime-dir', type: 'string',
       description: 'Path used at runtime to locate iconv CCS files')
option('newlib-iconv-encodings-exclude', type: 'array',
       description: 'enable specific comma-separated list of bidirectional iconv encodings to be excluded')

option('newlib-locale-info', type: 'boolean', value: false,
       description: 'locale support')
option('newlib-locale-info-extended', type: 'boolean', value: false,
       description: 'extended locale support')
option('newlib-mb', type: 'boolean', value: false,
       description: 'enable multibyte support')

#
# Startup/shutdown options
#
option('lite-exit', type: 'boolean', value: true,
       description: 'enable light weight exit')
option('newlib-atexit-dynamic-alloc', type: 'boolean', value: false,
       description: 'enable dynamic allocation of atexit entries')
option('newlib-global-atexit', type: 'boolean', value: false,
       description: 'enable atexit data structure as global')
option('newlib-initfini', type: 'boolean', value: true,
       description: 'Supports _init() and _fini()')
option('newlib-initfini-array', type: 'boolean', value: true,
       description: 'compiler supports INIT_ARRAY section types')
option('newlib-register-fini', type: 'boolean', value: false,
       description: 'enable finalization function registration using atexit')
option('fake-semihost', type: 'boolean', value: false,
       description: 'create fake semihost library to link tests')
option('crt-runtime-size', type: 'boolean', value: false,
       description: 'compute crt memory space sizes at runtime')

#
# Malloc option
#
option('newlib-nano-malloc', type: 'boolean', value: true,
       description: 'use small-footprint nano-malloc implementation')

#
# Locking support
#
option('newlib-multithread', type: 'boolean', value: true,
       description: 'enable support for multiple threads')
option('newlib-retargetable-locking', type: 'boolean', value: true,
       description: 'Allow locking routines to be retargeted at link time')

#
# Thread-local storage support
#
option('thread-local-storage', type: 'combo', choices: ['true', 'false', 'auto', 'picolibc'], value: 'picolibc',
       description: 'use thread local storage for static data ("picolibc": picolibc and toolchain support) ("auto": toolchain supports) (default: "picolibc")')
option('tls-model', type: 'combo', choices: ['global-dynamic', 'local-dynamic', 'initial-exec', 'local-exec'], value: 'local-exec',
       description: 'Set TLS model. No-op when thread-local-storage is false')
option('newlib-global-errno', type: 'boolean', value: false,
       description: 'use global errno variable')
option('errno-function', type: 'string',
       value: 'false',
       description: 'Use this function to compute errno address (default false, auto means autodetect, zephyr means use z_errno_wrap if !tls)')

#
# Math options
#
# Use "obsolete" math code, which use 'float' for 'float' functions
# instead of the newer code which uses 'double' instead.
#

=== semihost/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

picolibc_headers("" semihost.h)

add_library(semihost STATIC)

target_compile_options(semihost PRIVATE ${PICOLIBC_COMPILE_OPTIONS})

target_include_directories(semihost SYSTEM PUBLIC ${PICOLIBC_INCLUDE_DIRECTORIES})

add_subdirectory(machine/${CMAKE_SYSTEM_PROCESSOR})

target_sources(semihost PRIVATE
  close.c
  exit.c
  fstat.c
  gettimeofday.c
  isatty.c
  kill.c
  lseek.c
  lseek64.c
  open.c
  read.c
  unlink.c
  write.c
  sys_clock.c
  sys_close.c
  sys_elapsed.c
  sys_errno.c
  sys_exit.c
  sys_exit_extended.c
  sys_feature.c
  sys_flen.c
  sys_get_cmdline.c
  sys_getc.c
  sys_heapinfo.c
  sys_iserror.c
  sys_istty.c
  sys_open.c
  sys_putc.c
  sys_read.c
  sys_remove.c
  sys_rename.c
  sys_seek.c
  sys_system.c
  sys_tickfreq.c
  sys_time.c
  sys_tmpnam.c
  sys_write.c
  sys_write0.c
  iob.c
  )

=== test/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#

set(tests
  printf_scanf
  printf-tests
  rand
  regex
  ungetc
  fenv
  long_double
  math_errhandling
  malloc
  tls
  ffs
  setjmp
  atexit
  on_exit
  math-funcs
  timegm
  time-tests
  test-strtod
  test-strchr
  test-memset
  test-put
  test-efcvt
  malloc_stress
  posix-io
  )

set(tests_fail
  test-except
  )
  
function(picolibc_test test)
  add_executable(${test} ${test}.c ${ARGN})

  target_link_libraries(${test} LINK_PUBLIC ${PICOLIBC_TEST_LINK_LIBRARIES})

  target_compile_options(${test} PRIVATE "-fno-builtin" ${PICOLIBC_COMPILE_OPTIONS})

  add_test(
    NAME ${test}
    COMMAND "${PICOLIBC_SCRIPTS}/run-thumbv7m" $<TARGET_FILE:${test}>
    )
  set_tests_properties(${test} PROPERTIES SKIP_RETURN_CODE 77)
endfunction()

foreach(test IN LISTS tests)
  picolibc_test(${test})
endforeach()

foreach(test IN LISTS tests_fail)
  picolibc_test(${test})
  set_tests_properties(${test} PROPERTIES WILL_FAIL ON)
endforeach()

picolibc_test(rounding-mode rounding-mode-sub.c)

=== newlib/libc/ctype/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  categories.c
  ctype_.c
  isalnum.c
  isalnum_l.c
  isalpha.c
  isalpha_l.c
  isascii.c
  isascii_l.c
  isblank.c
  isblank_l.c
  iscntrl.c
  iscntrl_l.c
  isdigit.c
  isdigit_l.c
  islower.c
  islower_l.c
  isprint.c
  isprint_l.c
  ispunct.c
  ispunct_l.c
  isspace.c
  isspace_l.c
  isupper.c
  isupper_l.c
  iswalnum.c
  iswalnum_l.c
  iswalpha.c
  iswalpha_l.c
  iswblank.c
  iswblank_l.c
  iswcntrl.c
  iswcntrl_l.c
  iswctype.c
  iswctype_l.c
  iswdigit.c
  iswdigit_l.c
  iswgraph.c
  iswgraph_l.c
  iswlower.c
  iswlower_l.c
  iswprint.c
  iswprint_l.c
  iswpunct.c
  iswpunct_l.c
  iswspace.c
  iswspace_l.c
  iswupper.c
  iswupper_l.c
  iswxdigit.c
  iswxdigit_l.c
  isxdigit.c
  isxdigit_l.c
  jp2uc.c
  toascii.c
  toascii_l.c
  tolower.c
  tolower_l.c
  toupper.c
  toupper_l.c
  towctrans.c
  towctrans_l.c
  towlower.c
  towlower_l.c
  towupper.c
  towupper_l.c
  wctrans.c
  wctrans_l.c
  wctype.c
  wctype_l.c
  )

=== newlib/libc/include/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
add_subdirectory(sys)
add_subdirectory(machine)
add_subdirectory(ssp)
add_subdirectory(rpc)
add_subdirectory(arpa)

picolibc_headers(""
  alloca.h
  _ansi.h
  argz.h
  ar.h
  assert.h
  byteswap.h
  cpio.h
  ctype.h
  devctl.h
  dirent.h
  elf.h
  endian.h
  envlock.h
  envz.h
  errno.h
  fastmath.h
  fcntl.h
  fenv.h
  fnmatch.h
  getopt.h
  glob.h
  grp.h
  iconv.h
  ieeefp.h
  inttypes.h
  langinfo.h
  libgen.h
  limits.h
  locale.h
  malloc.h
  math.h
  memory.h
  newlib.h
  paths.h
  picotls.h
  pwd.h
  regdef.h
  regex.h
  sched.h
  search.h
  setjmp.h
  signal.h
  spawn.h
  stdint.h
  stdlib.h
  string.h
  strings.h
  _syslist.h
  tar.h
  termios.h
  threads.h
  time.h
  unctrl.h
  unistd.h
  utime.h
  utmp.h
  wchar.h
  wctype.h
  wordexp.h
  )

if(${_HAVE_COMPLEX})
  picolibc_headers(""
    complex.h
    )
endif()

=== newlib/libc/posix/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  basename.c
  dirname.c
  fnmatch.c
  regcomp.c
  regerror.c
  regexec.c
  regfree.c
  )

if(__HAVE_LOCALE_INFO)
  picolibc_sources(
    'collate.c',
    'collcmp.c',
    )
endif()

=== newlib/libc/stdlib/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  a64l.c
  abort.c
  abs.c
  aligned_alloc.c
  arc4random.c
  arc4random_uniform.c
  assert.c
  atof.c
  atoff.c
  atoi.c
  atol.c
  atoll.c
  btowc.c
  div.c
  drand48.c
  environ.c
  eprintf.c
  erand48.c
  _Exit.c
  getenv.c
  getenv_r.c
  getopt.c
  getsubopt.c
  imaxabs.c
  imaxdiv.c
  itoa.c
  jrand48.c
  l64a.c
  labs.c
  lcong48.c
  ldiv.c
  llabs.c
  lldiv.c
  lrand48.c
  mblen.c
  mbrlen.c
  mbrtowc.c
  mbsinit.c
  mbsnrtowcs.c
  mbsrtowcs.c
  mbstowcs.c
  mbtowc.c
  mbtowc_r.c
  mrand48.c
  mstats.c
  nrand48.c
  putenv.c
  rand48.c
  rand.c
  random.c
  rand_r.c
  reallocarray.c
  reallocf.c
  rpmatch.c
  sb_charsets.c
  seed48.c
  setenv.c
  srand.c
  srand48.c
  srandom.c
  system.c
  utoa.c
  wcrtomb.c
  wcsnrtombs.c
  wcsrtombs.c
  wcstod.c
  wcstoimax.c
  wcstol.c
  wcstoll.c
  wcstombs.c
  wcstoul.c
  wcstoull.c
  wcstoumax.c
  wctob.c
  wctomb.c
  wctomb_r.c
  pico-atexit.c
  pico-exit.c
  pico-onexit.c
  pico-cxa-atexit.c
  )

picolibc_sources_flags("-fno-builtin-malloc;-fno-builtin-free"
  nano-malloc-calloc.c
  nano-malloc-cfree.c
  nano-malloc-free.c
  nano-malloc-getpagesize.c
  nano-malloc-mallinfo.c
  nano-malloc-malloc.c
  nano-malloc-malloc_stats.c
  nano-malloc-malloc_usable_size.c
  nano-malloc-mallopt.c
  nano-malloc-memalign.c
  nano-malloc-posix_memalign.c
  nano-malloc-pvalloc.c
  nano-malloc-realloc.c
  nano-malloc-valloc.c
  )

=== newlib/libc/time/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  asctime.c
  asctime_r.c
  clock.c
  ctime.c
  ctime_r.c
  difftime.c
  gettzinfo.c
  gmtime.c
  gmtime_r.c
  lcltime.c
  lcltime_r.c
  lcltime_buf.c
  mktime.c
  month_lengths.c
  strftime.c
  strptime.c
  time.c
  tzcalc_limits.c
  tzset.c
  tzvars.c
  )

=== newlib/libc/tinystdio/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  asprintf.c
  bufio.c
  clearerr.c
  ecvt_r.c
  ecvt.c
  ecvtf_r.c
  ecvtf.c
  fcvt.c
  fcvt_r.c
  fcvtf.c
  fcvtf_r.c
  gcvt.c
  gcvtf.c
  fclose.c
  fdevopen.c
  feof.c
  ferror.c
  fflush.c
  fgetc.c
  fgets.c
  fileno.c
  filestrget.c
  filestrput.c
  filestrputalloc.c
  fmemopen.c
  fprintf.c
  fputc.c
  fputs.c
  fread.c
  freopen.c
  fscanf.c
  fseek.c
  fseeko.c
  ftell.c
  ftello.c
  fwrite.c
  getchar.c
  gets.c
  matchcaseprefix.c
  mktemp.c
  perror.c
  printf.c
  putchar.c
  puts.c
  remove.c
  rewind.c
  scanf.c
  setbuf.c
  setbuffer.c
  setlinebuf.c
  setvbuf.c
  snprintf.c
  sprintf.c
  snprintfd.c
  snprintff.c
  sprintff.c
  sprintfd.c
  sscanf.c
  strfromf.c
  strfromd.c
  strtof.c
  strtof_l.c
  strtod.c
  strtod_l.c
  strtoimax.c
  strtol.c
  strtoll.c
  strtoul.c
  strtoull.c
  strtoumax.c
  tmpnam.c
  tmpfile.c
  ungetc.c
  vasprintf.c
  vfiprintf.c
  vfprintf.c
  vfprintff.c
  vfscanf.c
  vfiscanf.c
  vfscanff.c
  vprintf.c
  vscanf.c
  vsscanf.c
  vsnprintf.c
  vsprintf.c
  dtoa_ryu.c
  ftoa_ryu.c
  ryu_table.c
  atod_ryu.c
  atof_ryu.c
  ryu_log2pow5.c
  ryu_log10.c
  ryu_pow5bits.c
  ryu_umul128.c
  ryu_divpow2.c
  fopen.c
  fdopen.c
  fclose.c
  sflags.c
  )

if(POSIX_CONSOLE)
  picolibc_sources(
    posixiob.c
    )
endif()

picolibc_headers(""
  stdio.h
  stdio-bufio.h
  )

=== newlib/libm/common/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
#
# Copyright © 2022 Keith Packard
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above
#    copyright notice, this list of conditions and the following
#    disclaimer in the documentation and/or other materials provided
#    with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
target_include_directories(c PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}")

picolibc_sources(
  signgam.c
  s_finite.c
  s_copysign.c
  s_modf.c
  s_scalbn.c
  s_cbrt.c
  s_exp10.c
  s_expm1.c
  s_ilogb.c
  s_infinity.c
  s_iseqsig.c
  s_isinf.c
  s_isinfd.c
  s_isnan.c
  s_isnand.c
  s_issignaling.c
  s_log1p.c
  s_nan.c
  s_nextafter.c
  s_pow10.c
  s_rint.c
  s_logb.c
  s_log2.c
  s_fdim.c
  s_fma.c
  s_fmax.c
  s_fmin.c
  s_fpclassify.c
  s_getpayload.c
  s_lrint.c
  s_llrint.c
  s_lround.c
  s_llround.c
  s_nearbyint.c
  s_remquo.c
  s_round.c
  s_scalbln.c
  s_signbit.c
  s_trunc.c
  exp_data.c
  math_err_with_errno.c
  math_err_uflow.c
  math_err_oflow.c
  math_err_divzero.c
  math_err_invalid.c
  math_err_may_uflow.c
  math_err_check_uflow.c
  math_err_check_oflow.c
  math_inexact.c
  math_inexactf.c
  log_data.c
  log2_data.c
  pow.c
  pow_log_data.c
  sf_finite.c
  sf_copysign.c
  sf_modf.c
  sf_scalbn.c
  sf_cbrt.c
  sf_exp10.c
  sf_expm1.c
  sf_getpayload.c
  sf_ilogb.c
  sf_infinity.c
  sf_iseqsig.c
  sf_isinf.c
  sf_isinff.c
  sf_isnan.c
  sf_isnanf.c
  sf_issignaling.c
  sf_log1p.c
  sf_nan.c
  sf_nextafter.c
  sf_pow10.c
  sf_rint.c
  sf_logb.c
  sf_fdim.c
  sf_fma.c
  sf_fmax.c
  sf_fmin.c
  sf_fpclassify.c
  sf_lrint.c
  sf_llrint.c
  sf_lround.c
  sf_llround.c
  sf_nearbyint.c
  sf_remquo.c
  sf_round.c
  sf_scalbln.c
  sf_trunc.c
  sf_exp2_data.c
  sf_log_data.c
  sf_log2_data.c
  sf_pow_log2_data.c
  sinf.c
  sincosf.c
  sincosf_data.c
  math_errf_with_errnof.c
  math_errf_uflowf.c
  math_errf_may_uflowf.c
  math_errf_oflowf.c
  math_errf_divzerof.c
  math_errf_invalidf.c
  math_errf_check_oflowf.c
  math_errf_check_uflowf.c
)

if(_HAVE_LONG_DOUBLE)
  picolibc_sources(
    copysignl.c
    frexpl.c
    exp10l.c
    fabsl.c
    frexpl.c
    isinfl.c
    isnanl.c
    math_errl_check_oflowl.c
    math_errl_check_uflowl.c
    math_errl_divzerol.c
    math_errl_invalidl.c
    math_errl_oflowl.c
    math_errl_uflowl.c
    math_errl_with_errnol.c
    math_inexactl.c
    nanl.c
    nexttoward.c
    nexttowardf.c
    sl_iseqsig.c
    sl_issignaling.c
  )
endif()

=== newlib/libm/complex/CMakeLists.txt ===
# FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
# COPYRIGHT HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT,
# INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
# (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR
# SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
# HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT,
# STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED
# OF THE POSSIBILITY OF SUCH DAMAGE.
#
picolibc_sources(
  cabs.c
  cacos.c
  cacosh.c
  carg.c
  casin.c
  casinh.c
  catan.c
  catanh.c
  ccos.c
  ccosh.c
  cephes_subr.c
  cexp.c
  cimag.c
  clog.c
  clog10.c
  conj.c
  cpow.c
  cproj.c
  creal.c
  csin.c
  csinh.c
  csqrt.c
  ctan.c
  ctanh.c
  cabsf.c
  casinf.c
  ccosf.c
  cimagf.c
  cprojf.c
  csqrtf.c
  cacosf.c
  casinhf.c
  ccoshf.c
  clogf.c
  clog10f.c
  crealf.c
  ctanf.c
  cacoshf.c
  catanf.c
  cephes_subrf.c
  conjf.c
  csinf.c
  ctanhf.c
  cargf.c
  catanhf.c
  cexpf.c
  cpowf.c
  csinhf.c
  )

if(${_HAVE_LONG_DOUBLE})
  picolibc_sources(
    cabsl.c
    creall.c
    cimagl.c
    conjl.c
    cprojl.c
    csqrtl.c
    cacoshl.c
    cacosl.c
    cargl.c
    casinhl.c
    casinl.c
    catanhl.c
    catanl.c
    cephes_subrl.c
    ccoshl.c
    ccosl.c
    cexpl.c
    clog10l.c
    clogl.c
    cpowl.c
    csinhl.c
    csinl.c
    ctanhl.c
    ctanl.c
    )
endif()

=== debian/changelog ===
picolibc (1.8-1) unstable; urgency=medium

  * New upstream

  * long double math library support

 -- Keith Packard <keithp@keithp.com>  Thu, 22 Dec 2022 12:35:12 -0800

=== debian/control ===
Source: picolibc
Priority: optional
Maintainer: Keith Packard <keithp@keithp.com>
Build-Depends: debhelper-compat (= 13), gcc-arm-none-eabi, gcc-riscv64-unknown-elf, gcc-xtensa-lx106,
 gcc-aarch64-linux-gnu, meson, ninja-build, qemu-system-arm
Standards-Version: 4.6.2
Rules-Requires-Root: no
Section: devel
Homepage: https://keithp.com/picolibc
Vcs-Git: git://keithp.com/git/picolibc.git
Vcs-Browser: https://keithp.com/cgit/picolibc.git/

Package: picolibc-riscv64-unknown-elf
Architecture: all
Depends: ${misc:Depends}, gcc-riscv64-unknown-elf
Description: Smaller embedded C library for RISC-V development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 RISC-V processors.

Package: picolibc-arm-none-eabi
Architecture: all
Depends: ${misc:Depends}, gcc-arm-none-eabi
Description: Smaller embedded C library for ARM development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ARM processors. This library is intended to replace libnewlib-nano

Package: picolibc-xtensa-lx106-elf
Architecture: all
Depends: ${misc:Depends}, gcc-xtensa-lx106
Description: Smaller embedded C library for ESP8266 development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ESP8266 processors.

Package: picolibc-aarch64-linux-gnu
Architecture: all
Depends: ${misc:Depends}, gcc-aarch64-linux-gnu
Description: Smaller embedded C library for 64-bit ARM development
 PicoLibc is a combination of Newlib and AVR libc bits designed
 for small-RAM embedded systems. This package has binaries for
 ARM 64-bit processors.

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# Don't let dpkg-buildflags mess with the compiler settings
export DEB_CPPFLAGS_MAINT_SET =
export DEB_CFLAGS_MAINT_SET =
export DEB_LDFLAGS_MAINT_SET =

BUILDDIR=build

BUILDPATH=$(shell pwd)/debian/$(BUILDDIR)

%:
	dh $@ -B$(BUILDDIR)

RISCV_ARCH=riscv64-unknown-elf
ARM_ARCH=arm-none-eabi
LX106_ARCH=xtensa-lx106-elf
AARCH64_ARCH=aarch64-linux-gnu

MESON_SHARED_C_ARGS = -Wdate-time -ffile-prefix-map=$(BUILDPATH)=. -fdebug-prefix-map=$(BUILDPATH)=.

MESON_SHARED_FLAGS = \
	--prefix=/usr

MESON_RELEASE_FLAGS=-Dbuild-type-subdir=release --buildtype=release

MESON_RISCV_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS) -msave-restore' \
	--cross-file scripts/cross-$(RISCV_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib

MESON_RISCV_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(RISCV_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(RISCV_ARCH) \
	-Dincludedir=lib/picolibc/$(RISCV_ARCH)/include \
	-Dlibdir=lib/picolibc/$(RISCV_ARCH)/lib

MESON_ARM_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(ARM_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib

MESON_ARM_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(ARM_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(ARM_ARCH) \
	-Dincludedir=lib/picolibc/$(ARM_ARCH)/include \
	-Dlibdir=lib/picolibc/$(ARM_ARCH)/lib

MESON_LX106_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(LX106_ARCH).txt \
	-Dnewlib-long-time_t=true \
	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
	-Dincludedir=lib/$(LX106_ARCH)/include \
	-Dlibdir=lib/$(LX106_ARCH)/lib

MESON_LX106_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	--cross-file scripts/cross-$(LX106_ARCH).txt \
	-Dnewlib-long-time_t=true \
	-Dspecsdir=/usr/lib/$(LX106_ARCH) \
	-Dincludedir=lib/$(LX106_ARCH)/include \
	-Dlibdir=lib/$(LX106_ARCH)/lib

MESON_AARCH64_MINSIZE_FLAGS = \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(AARCH64_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(AARCH64_ARCH) \
	-Dincludedir=lib/picolibc/$(AARCH64_ARCH)/include \
	-Dlibdir=lib/picolibc/$(AARCH64_ARCH)/lib

MESON_AARCH64_RELEASE_FLAGS = \
	$(MESON_RELEASE_FLAGS) \
	$(MESON_SHARED_FLAGS) \
	-Dc_args='$(MESON_SHARED_C_ARGS)' \
	-Dtests=true \
	--cross-file scripts/cross-$(AARCH64_ARCH).txt \
	-Dspecsdir=/usr/lib/picolibc/$(AARCH64_ARCH) \
	-Dincludedir=lib/picolibc/$(AARCH64_ARCH)/include \
	-Dlibdir=lib/picolibc/$(AARCH64_ARCH)/lib

override_dh_autoreconf:
	echo 'no reconf needed'

override_dh_auto_clean:
	rm -fr debian/$(BUILDDIR)

override_dh_auto_configure:
	meson . debian/$(BUILDDIR)/$(RISCV_ARCH) $(MESON_RISCV_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(ARM_ARCH) $(MESON_ARM_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(LX106_ARCH) $(MESON_LX106_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(AARCH64_ARCH) $(MESON_AARCH64_MINSIZE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(RISCV_ARCH)-release $(MESON_RISCV_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(ARM_ARCH)-release $(MESON_ARM_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(LX106_ARCH)-release $(MESON_LX106_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'
	meson . debian/$(BUILDDIR)/$(AARCH64_ARCH)-release $(MESON_AARCH64_RELEASE_FLAGS) 2>&1 | grep -v 'path separator\|This is not supported\|a hard error in the future'

override_dh_auto_build:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && ninja -v
	cd debian/$(BUILDDIR)/$(RISCV_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(LX106_ARCH)-release && ninja -v
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && ninja -v

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && meson test --timeout-multiplier=10
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && meson test --timeout-multiplier=10
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && meson test --timeout-multiplier=10
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && meson test --timeout-multiplier=10
endif

override_dh_auto_install:
	cd debian/$(BUILDDIR)/$(RISCV_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(ARM_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(LX106_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH) && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(RISCV_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(ARM_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(LX106_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install
	cd debian/$(BUILDDIR)/$(AARCH64_ARCH)-release && DESTDIR=${CURDIR}/debian/tmp ninja install

=== debian/tests/control ===
Test-Command: riscv64-unknown-elf-gcc -fno-stack-protector --specs=picolibc.specs -o /tmp/touch-risc-v debian/tests/touch.c
Depends: @, gcc-riscv64-unknown-elf
Architecture: amd64, i386, pcc64el

Test-Command: arm-none-eabi-gcc -fno-stack-protector --specs=picolibc.specs -o /tmp/touch-arm debian/tests/touch.c
Depends: @, gcc-arm-none-eabi
Architecture: amd64, i386, pcc64el

Test-Command: aarch64-linux-gnu-gcc -fno-stack-protector --specs=picolibc.specs -o /tmp/touch-aarch64 debian/tests/touch.c
Depends: @, gcc-arm-none-eabi
Architecture: amd64, i386, pcc64el
